<?php
/**
* VirtueMart Search Bot
* @version 1.0
* @package VirtueMart
* @copyright (C) Copyright 2004-2005 by Soeren Eberhardt
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/** Register search function inside Mambo's API */
$_MAMBOTS->registerFunction( 'onSearch', 'botSearchJshopping' );

/**
* Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
*/
function botSearchJshopping( $text, $phrase='', $ordering='' ) {
  global $database;
  $text = trim( $text );
  if ($text == '') {
    return array();
  }
	$wheres = array();
	switch ($phrase) {
		case 'exact':
			$wheres2 = array();
			$wheres2[] = "LOWER(prod_descr.product_name) LIKE '%$text%'";
			$wheres2[] = "LOWER(prod_descr.product_description) LIKE '%$text%'";
			$wheres2[] = "LOWER(prod_descr.product_short_description) LIKE '%$text%'";
			$where = '(' . implode( ') OR (', $wheres2 ) . ')';
			break;
		case 'all':
		case 'any':
		default:
			$words = explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word) {
				$wheres2 = array();
				$wheres2[] = "LOWER(prod_descr.product_name) LIKE '%$word%'";
				$wheres2[] = "LOWER(prod_descr.product_description) LIKE '%$word%'";
				$wheres2[] = "LOWER(prod_descr.product_short_description) LIKE '%$word%'";
				$wheres[] = implode( ' OR ', $wheres2 );
			}
			$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
			break;
	}

	switch ($ordering) {
		case 'newest':
		default:
			$order = 'prod.product_date_added DESC';
			break;
		case 'oldest':
			$order = 'prod.product_date_added ASC';
			break;
		case 'popular':
			$order = 'prod_descr.product_name ASC';
			break;
		case 'alpha':
			$order = 'prod_descr.product_name ASC';
			break;
		case 'category':
			$order = 'categ.category_id ASC';
			break;
	}


  $database->setQuery( "SELECT menu.id, menu.name FROM  `#__menu` AS menu WHERE menu.link LIKE '%com_jshopping%' AND menu.published=1 AND menu.access=0");
  $database->loadObject( $Item );
  $ItemName = !empty( $Item->name ) ? $Item->name : "shop";
  $Itemid = !empty( $Item->id ) ? $Item->id : "1";

  $query = "SELECT DISTINCT prod.product_id, prod_descr.product_name as title,"
               . "\n    prod.product_date_added AS created,"
               . "\n    prod_descr.product_short_description AS text,"
               . "\n    CONCAT('$ItemName/',categ_descr.category_name) as section,"
               . "\n    CONCAT('index.php?option=com_jshopping&task=product&product_id=',prod.product_id,'&category_id=',categ.category_id, '&Itemid=".$Itemid."' ) as href,"
               . "\n    '2' as browsernav"
               . "\n FROM #__jshopping_products AS prod"
               . "\n LEFT JOIN `#__jshopping_products_description` AS prod_descr ON prod.product_id = prod_descr.product_id"
               . "\n LEFT JOIN `#__jshopping_products_to_categories` AS prod_cat ON prod_cat.product_id = prod.product_id"
               . "\n LEFT JOIN `#__jshopping_categories` AS categ ON prod_cat.category_id = categ.category_id"
               . "\n LEFT JOIN `#__jshopping_categories_description` AS categ_descr ON categ.category_id = categ_descr.category_id"
               . "\n WHERE $where"
			   . "\n AND prod.product_publish='1'"
               . "\n GROUP BY prod.product_id ORDER BY $order" ;
  $database->setQuery( $query );

  $rows = $database->loadObjectList();
  foreach($rows as $key=>$value){
  	$rows[$key]->href = sefRelToAbs($value->href);
  }
  return $rows;
}

?>
